/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmbitctrlablauf.attribute;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Typ eines Kommandos an den Ablaufprogramm-Server.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 1
 */
public class AttBcAblaufServerKommandoTyp extends Zahl<		Byte
> {
	
	private static final long serialVersionUID = 1L;
	
	
	/**
	
	<p>
	
	</p>
	*/
	public static final AttBcAblaufServerKommandoTyp ZUSTAND_0_SCHALTEN = new AttBcAblaufServerKommandoTyp("Schalten", 		Byte
	.valueOf("0"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttBcAblaufServerKommandoTyp ZUSTAND_1_ABBRECHEN = new AttBcAblaufServerKommandoTyp("Abbrechen", 		Byte
	.valueOf("1"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttBcAblaufServerKommandoTyp ZUSTAND_2_NEUES_PROGRAMM_ANLEGEN = new AttBcAblaufServerKommandoTyp("Neues Programm anlegen", 		Byte
	.valueOf("2"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttBcAblaufServerKommandoTyp ZUSTAND_3_PROGRAMM_LOESCHEN = new AttBcAblaufServerKommandoTyp("Programm löschen", 		Byte
	.valueOf("3"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttBcAblaufServerKommandoTyp ZUSTAND_4_PROGRAMM_BEARBEITEN = new AttBcAblaufServerKommandoTyp("Programm bearbeiten", 		Byte
	.valueOf("4"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttBcAblaufServerKommandoTyp ZUSTAND_5_PROGRAMM_FREIGEBEN = new AttBcAblaufServerKommandoTyp("Programm freigeben", 		Byte
	.valueOf("5"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttBcAblaufServerKommandoTyp ZUSTAND_6_PROGRAMM_EINPLANEN = new AttBcAblaufServerKommandoTyp("Programm einplanen", 		Byte
	.valueOf("6"));

	/**
	 * Gibt den Zustand zu einer Zahl zurück oder <code>null</code>, wenn die
	 * Zahl keinen Zustand repräsentiert.
	 *
	 * @param value ein Zahlenwert
	 * @return der Zustand zu dem Zahlenwert oder <code>null</code>, wenn die
	 * Zahl keine Entsprechnung als Zustand besitzt.
	 */
	public static AttBcAblaufServerKommandoTyp getZustand(final 		Byte
	 value) {
		for (AttBcAblaufServerKommandoTyp e : getZustaende()) {
			if (e.getValue().equals(value)) {
				return e;
			}
		}
		return null;
	}
	
	/**
	 * Gibt den Zustand zu einem Zustandsnamen zurück oder <code>null</code>,
	 * wenn kein Zustand einen solchen Namen hat.
	 * 
	 * @param value
	 *            der Zustandsname
	 * @return der Zustand zu dem Zustandsnamen oder <code>null</code>, wenn
	 *         kein Zustand einen solchen Namen hat.
	 */
	public static AttBcAblaufServerKommandoTyp getZustand(final String value) {
		for (AttBcAblaufServerKommandoTyp e : getZustaende()) {
			if (e.toString().equals(value)) {
				return e;
			}
		}
		return null;
	}
	
	/**
	 * Gibt alle Zustände zurück, die das Attribut besitzen kann.
	 *
	 * @return alle Zustände die das Attribut annehmen kann.
	 */
	public static List<AttBcAblaufServerKommandoTyp> getZustaende() {
		List<AttBcAblaufServerKommandoTyp> list = new ArrayList<AttBcAblaufServerKommandoTyp>();
		list.add(ZUSTAND_0_SCHALTEN);
		list.add(ZUSTAND_1_ABBRECHEN);
		list.add(ZUSTAND_2_NEUES_PROGRAMM_ANLEGEN);
		list.add(ZUSTAND_3_PROGRAMM_LOESCHEN);
		list.add(ZUSTAND_4_PROGRAMM_BEARBEITEN);
		list.add(ZUSTAND_5_PROGRAMM_FREIGEBEN);
		list.add(ZUSTAND_6_PROGRAMM_EINPLANEN);
		return list;
	}	
	/**
	 * Erzeugte eine neues Attribut AblaufServerKommandoTyp.
	 *
	 * @param value der Wert der Zahl.
	 */
	public AttBcAblaufServerKommandoTyp(final 		Byte
	 value) {
		super(value);
	}
	
	private AttBcAblaufServerKommandoTyp(final String zustand, final 		Byte
	 value) {
		super(zustand, value);
	}
	
}
