/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmganglinienglobal.onlinedaten;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Attributgruppe mit den Antworten des Ganglininespeichers auf Anfragen.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 11
 */
public class OdGanglinienSpeicherAntwort extends AbstractOnlineDatensatz<OdGanglinienSpeicherAntwort.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.Antwort,
				};
			}
	
			/**
			 * Wird zur Beantwortung von Anfragen benutzt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt Antwort = new Aspekte("Antwort", "asp.antwort");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractOnlineDatum {
		
		/**
		 * Initialisiert das Onlinedatum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private 	de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.Applikation
				 _absenderId
				;
				private String
				 _absenderZeichen
				= new String
				()
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmganglinienglobal.attribute.AtlGanglinienSpeicherAntwort
				 _antwort
				= new de.bsvrz.sys.funclib.bitctrl.modell.tmganglinienglobal.attribute.AtlGanglinienSpeicherAntwort
				()
				;
		
			/**
			Objekt-ID der anfragenden Applikation.
			<p>
			&lt;absatz&gt;
										Die Objekt-ID wird aus der Anfrage in die Antwort kopiert. Jeder angemeldete Client muss diese auswerten, damit er nur Antworten auf seine eigenen Anfragen auswertet.
									&lt;&#47;absatz&gt;
			</p>
			
			@return der Wert von AbsenderId.
			*/
				public 	de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.Applikation
				 getAbsenderId() {
				return _absenderId;
			}
		
			/**
			Objekt-ID der anfragenden Applikation.
			<p>
			&lt;absatz&gt;
										Die Objekt-ID wird aus der Anfrage in die Antwort kopiert. Jeder angemeldete Client muss diese auswerten, damit er nur Antworten auf seine eigenen Anfragen auswertet.
									&lt;&#47;absatz&gt;
			</p>
			
			@param _absenderId der neue Wert von AbsenderId.
			*/
			public void setAbsenderId(	de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.Applikation
			 _absenderId) {
				this._absenderId = _absenderId;
			}
		
			/**
			Kennzeichnung, die von der anfragenden Applikation beliebig vergeben wird.
			<p>
			Der angegebene Wert wird in die Antwort aus der Anfrage kopiert. Die Bedeutung des Attributs wird von der anfragenden Applikation beliebig festgelegt und kann zum Beispiel dazu benutzt werden, um eine empfangene Antwort der ursprünglichen Anfrage zuzuordnen.
			</p>
			
			@return der Wert von AbsenderZeichen.
			*/
				public String
				 getAbsenderZeichen() {
				return _absenderZeichen;
			}
		
			/**
			Kennzeichnung, die von der anfragenden Applikation beliebig vergeben wird.
			<p>
			Der angegebene Wert wird in die Antwort aus der Anfrage kopiert. Die Bedeutung des Attributs wird von der anfragenden Applikation beliebig festgelegt und kann zum Beispiel dazu benutzt werden, um eine empfangene Antwort der ursprünglichen Anfrage zuzuordnen.
			</p>
			
			@param _absenderZeichen der neue Wert von AbsenderZeichen.
			*/
			public void setAbsenderZeichen(String
			 _absenderZeichen) {
				if (_absenderZeichen.length() > 32767) {
					throw new IllegalArgumentException("Der Text darf nicht länger als " + 32767 + " Zeichen sein.");
				}
				this._absenderZeichen = _absenderZeichen;
			}
		
			/**
			Anfrageergebnis nach Ganglinie.
			<p>
			
			</p>
			
			@return der Wert von Antwort.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmganglinienglobal.attribute.AtlGanglinienSpeicherAntwort
				 getAntwort() {
				return _antwort;
			}
		
			/**
			Anfrageergebnis nach Ganglinie.
			<p>
			
			</p>
			
			@param _antwort der neue Wert von Antwort.
			*/
			public void setAntwort(de.bsvrz.sys.funclib.bitctrl.modell.tmganglinienglobal.attribute.AtlGanglinienSpeicherAntwort
			 _antwort) {
				this._antwort = _antwort;
			}
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final Object soAbsenderId = getAbsenderId();
						final SystemObject tmpAbsenderId;
							if (soAbsenderId instanceof SystemObject) {
								tmpAbsenderId = (SystemObject)soAbsenderId;
							} else if(soAbsenderId instanceof SystemObjekt){
								tmpAbsenderId = ((SystemObjekt)soAbsenderId).getSystemObject();
							} else{
								tmpAbsenderId = null;
							}
						datum.getReferenceValue("absenderId").setSystemObject(tmpAbsenderId);
					// ZeichenkettenAttributTyp
					if (getAbsenderZeichen() != null) {
						datum.getTextValue("AbsenderZeichen").setText(getAbsenderZeichen());
					}
					// AttributListenDefinition
						getAntwort().bean2Atl(datum.getItem("Antwort"), factory);
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// ObjektReferenzAttributTyp
						final long idAbsenderId = daten.getReferenceValue("absenderId").getId();
						final SystemObjekt tmpAbsenderId;
						if (idAbsenderId == 0) {
							tmpAbsenderId = null;
						} else {
							final SystemObject soAbsenderId = factory.getDav().getDataModel().getObject(idAbsenderId);
							if (soAbsenderId == null) {
									tmpAbsenderId = new de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.impl.ApplikationUngueltig(idAbsenderId);
							} else {
								tmpAbsenderId = factory.getModellobjekt(soAbsenderId);
							}
						}
						setAbsenderId((	de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.Applikation
						) tmpAbsenderId);
					// ZeichenkettenAttributTyp
						setAbsenderZeichen(daten.getTextValue("AbsenderZeichen").getText());
					// AttributListenDefinition
						getAntwort().atl2Bean(daten.getItem("Antwort"), factory);
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon.setAbsenderId(getAbsenderId());
							klon.setAbsenderZeichen(getAbsenderZeichen());
							klon._antwort = getAntwort().clone();
			
			
			klon.dSetZeitstempel(dGetZeitstempel());
			klon.dSetDatenStatus(dGetDatenStatus());
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}

		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.ganglinienSpeicherAntwort";

	/**
	 * Initialisiert den Onlinedatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public OdGanglinienSpeicherAntwort(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 
	
}
