/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmkextlsglobal.attribute;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Zustand der Energieversorgung, Tiefentladeschutz.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 24
 */
@Wertebereich(
	minimum = 0L,
	maximum = 1L,
	einheit = ""
)
public class AttTlsVltEnergieversorgungZustandTiefentladeSchutz extends Zahl<		Byte
> {
	
	private static final long serialVersionUID = 1L;
	
	/**
	 * Der minimale Wert des Attributs.
	 *
	 * @deprecated neu: {@link WerteBereich#getWerteBereich(Class)} und {@link #getWerteBereich()}
	 */
	@Deprecated
	public static final 		Byte
	 MIN_VALUE =
				Byte
		.valueOf("0");
	
	/**
	 * Der maximale Wert des Attributs.
	 *
	 * @deprecated neu: {@link WerteBereich#getWerteBereich(Class)} und {@link #getWerteBereich()}
	 */
	@Deprecated
	public static final 		Byte
	 MAX_VALUE =
				Byte
		.valueOf("1");
	
	/**
	 * Die Einheit.
	 *
	 * @deprecated neu: {@link WerteBereich#getWerteBereich(Class)} und {@link #getWerteBereich()}
	 */
	@Deprecated
	public static final String EINHEIT = "";
	
	/**
	Tiefentladeschutz steht bevor.
	<p>
	
	</p>
	*/
	public static final AttTlsVltEnergieversorgungZustandTiefentladeSchutz ZUSTAND_0_TIEFENTLADESCHUTZ_STEHT_BEVOR = new AttTlsVltEnergieversorgungZustandTiefentladeSchutz("Tiefentladeschutz steht bevor", 		Byte
	.valueOf("0"));

	/**
	Tiefentladeschutz steht nicht bevor.
	<p>
	
	</p>
	*/
	public static final AttTlsVltEnergieversorgungZustandTiefentladeSchutz ZUSTAND_1_TIEFENTLADESCHUTZ_STEHT_NICHT_BEVOR = new AttTlsVltEnergieversorgungZustandTiefentladeSchutz("Tiefentladeschutz steht nicht bevor", 		Byte
	.valueOf("1"));

	/**
	 * Gibt den Zustand zu einer Zahl zurück oder <code>null</code>, wenn die
	 * Zahl keinen Zustand repräsentiert.
	 *
	 * @param value ein Zahlenwert
	 * @return der Zustand zu dem Zahlenwert oder <code>null</code>, wenn die
	 * Zahl keine Entsprechnung als Zustand besitzt.
	 */
	public static AttTlsVltEnergieversorgungZustandTiefentladeSchutz getZustand(final 		Byte
	 value) {
		for (AttTlsVltEnergieversorgungZustandTiefentladeSchutz e : getZustaende()) {
			if (e.getValue().equals(value)) {
				return e;
			}
		}
		return null;
	}
	
	/**
	 * Gibt den Zustand zu einem Zustandsnamen zurück oder <code>null</code>,
	 * wenn kein Zustand einen solchen Namen hat.
	 * 
	 * @param value
	 *            der Zustandsname
	 * @return der Zustand zu dem Zustandsnamen oder <code>null</code>, wenn
	 *         kein Zustand einen solchen Namen hat.
	 */
	public static AttTlsVltEnergieversorgungZustandTiefentladeSchutz getZustand(final String value) {
		for (AttTlsVltEnergieversorgungZustandTiefentladeSchutz e : getZustaende()) {
			if (e.toString().equals(value)) {
				return e;
			}
		}
		return null;
	}
	
	/**
	 * Gibt alle Zustände zurück, die das Attribut besitzen kann.
	 *
	 * @return alle Zustände die das Attribut annehmen kann.
	 */
	public static List<AttTlsVltEnergieversorgungZustandTiefentladeSchutz> getZustaende() {
		List<AttTlsVltEnergieversorgungZustandTiefentladeSchutz> list = new ArrayList<AttTlsVltEnergieversorgungZustandTiefentladeSchutz>();
		list.add(ZUSTAND_0_TIEFENTLADESCHUTZ_STEHT_BEVOR);
		list.add(ZUSTAND_1_TIEFENTLADESCHUTZ_STEHT_NICHT_BEVOR);
		return list;
	}	
	/**
	 * Erzeugte eine neues Attribut TLSVltEnergieversorgungZustandTiefentladeSchutz.
	 *
	 * @param value der Wert der Zahl.
	 */
	public AttTlsVltEnergieversorgungZustandTiefentladeSchutz(final 		Byte
	 value) {
		super(value);
	}
	
	private AttTlsVltEnergieversorgungZustandTiefentladeSchutz(final String zustand, final 		Byte
	 value) {
		super(zustand, value);
	}
	
}
