/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmkextlsglobal.konfigurationsdaten;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Konfigurierende Eigenschaften der Objekte des Typs.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 2
 */
public class KdAnschlussPunktKommunikationsPartner extends AbstractKonfigurationsDatensatz<KdAnschlussPunktKommunikationsPartner.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.Eigenschaften,
				};
			}
	
			/**
			 * Wird für konfigurierende Attributgruppen verwendet. Über die entsprechende Attributgruppe werden die konkreten Eigenschaften eines Objekts festgelegt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt Eigenschaften = new Aspekte("Eigenschaften", "asp.eigenschaften");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractDatum implements KonfigurationsDatum {
		
		/**
		 * Initialisiert das Datum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private String
				 _bezeichnung
				= new String
				()
				;
				private String
				 _protokollTyp
				= new String
				()
				;
				private 	de.bsvrz.sys.funclib.bitctrl.modell.tmkextlsglobal.objekte.Geraet
				 _kommunikationsPartner
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.fachmodellglobal.attribute.AttZahlPositiv
				 _portNummer
				;
		
			/**
			Bezeichnung des
									AnschlussPunktesKommunikationsPartner (zu
									Dokumentationszwecken).
			<p>
			
			</p>
			
			@return der Wert von Bezeichnung.
			*/
				public String
				 getBezeichnung() {
				return _bezeichnung;
			}
		
			/**
			Bezeichnung des
									AnschlussPunktesKommunikationsPartner (zu
									Dokumentationszwecken).
			<p>
			
			</p>
			
			@param _bezeichnung der neue Wert von Bezeichnung.
			*/
			public void setBezeichnung(String
			 _bezeichnung) {
				if (_bezeichnung.length() > 32767) {
					throw new IllegalArgumentException("Der Text darf nicht länger als " + 32767 + " Zeichen sein.");
				}
				this._bezeichnung = _bezeichnung;
			}
		
			/**
			Protokolltyp an diesem Anschlusspunkt.
			<p>
			&lt;absatz&gt;
										Der angegebene Text ist der Klassennamen des
										Protokollmoduls. Bei Angabe eines
										Leerstrings bei lokalen Verbindungen wird
										kein Kommunikationsprotokoll initialisiert.
									&lt;&#47;absatz&gt;
			</p>
			
			@return der Wert von ProtokollTyp.
			*/
				public String
				 getProtokollTyp() {
				return _protokollTyp;
			}
		
			/**
			Protokolltyp an diesem Anschlusspunkt.
			<p>
			&lt;absatz&gt;
										Der angegebene Text ist der Klassennamen des
										Protokollmoduls. Bei Angabe eines
										Leerstrings bei lokalen Verbindungen wird
										kein Kommunikationsprotokoll initialisiert.
									&lt;&#47;absatz&gt;
			</p>
			
			@param _protokollTyp der neue Wert von ProtokollTyp.
			*/
			public void setProtokollTyp(String
			 _protokollTyp) {
				if (_protokollTyp.length() > 32767) {
					throw new IllegalArgumentException("Der Text darf nicht länger als " + 32767 + " Zeichen sein.");
				}
				this._protokollTyp = _protokollTyp;
			}
		
			/**
			Referenz auf das Gerät, an dem der
									AnschlussPunktKommunikationsPartner ist.
			<p>
			
			</p>
			
			@return der Wert von KommunikationsPartner.
			*/
				public 	de.bsvrz.sys.funclib.bitctrl.modell.tmkextlsglobal.objekte.Geraet
				 getKommunikationsPartner() {
				return _kommunikationsPartner;
			}
		
			/**
			Referenz auf das Gerät, an dem der
									AnschlussPunktKommunikationsPartner ist.
			<p>
			
			</p>
			
			@param _kommunikationsPartner der neue Wert von KommunikationsPartner.
			*/
			public void setKommunikationsPartner(	de.bsvrz.sys.funclib.bitctrl.modell.tmkextlsglobal.objekte.Geraet
			 _kommunikationsPartner) {
				this._kommunikationsPartner = _kommunikationsPartner;
			}
		
			/**
			Portnummer des Anschlusspunktes.
			<p>
			
			</p>
			
			@return der Wert von PortNummer.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.fachmodellglobal.attribute.AttZahlPositiv
				 getPortNummer() {
				return _portNummer;
			}
		
			/**
			Portnummer des Anschlusspunktes.
			<p>
			
			</p>
			
			@param _portNummer der neue Wert von PortNummer.
			*/
			public void setPortNummer(de.bsvrz.sys.funclib.bitctrl.modell.fachmodellglobal.attribute.AttZahlPositiv
			 _portNummer) {
				this._portNummer = _portNummer;
			}
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// ZeichenkettenAttributTyp
					if (getBezeichnung() != null) {
						datum.getTextValue("Bezeichnung").setText(getBezeichnung());
					}
					// ZeichenkettenAttributTyp
					if (getProtokollTyp() != null) {
						datum.getTextValue("ProtokollTyp").setText(getProtokollTyp());
					}
					// ObjektReferenzAttributTyp
						final Object soKommunikationsPartner = getKommunikationsPartner();
						final SystemObject tmpKommunikationsPartner;
							if (soKommunikationsPartner instanceof SystemObject) {
								tmpKommunikationsPartner = (SystemObject)soKommunikationsPartner;
							} else if(soKommunikationsPartner instanceof SystemObjekt){
								tmpKommunikationsPartner = ((SystemObjekt)soKommunikationsPartner).getSystemObject();
							} else{
								tmpKommunikationsPartner = null;
							}
						datum.getReferenceValue("KommunikationsPartner").setSystemObject(tmpKommunikationsPartner);
					// GanzzahlAttributTyp
					if (getPortNummer() != null) {
		                if (getPortNummer().isZustand()) {
		                    datum.getUnscaledValue("PortNummer").setText(getPortNummer().toString());
		                } else {
							datum.
							getUnscaledValue
		                	("PortNummer").set(getPortNummer().getValue());
		                }
					}
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// ZeichenkettenAttributTyp
						setBezeichnung(daten.getTextValue("Bezeichnung").getText());
					// ZeichenkettenAttributTyp
						setProtokollTyp(daten.getTextValue("ProtokollTyp").getText());
					// ObjektReferenzAttributTyp
						final long idKommunikationsPartner = daten.getReferenceValue("KommunikationsPartner").getId();
						final SystemObjekt tmpKommunikationsPartner;
						if (idKommunikationsPartner == 0) {
							tmpKommunikationsPartner = null;
						} else {
							final SystemObject soKommunikationsPartner = factory.getDav().getDataModel().getObject(idKommunikationsPartner);
							if (soKommunikationsPartner == null) {
									tmpKommunikationsPartner = new de.bsvrz.sys.funclib.bitctrl.modell.tmkextlsglobal.objekte.impl.GeraetUngueltig(idKommunikationsPartner);
							} else {
								tmpKommunikationsPartner = factory.getModellobjekt(soKommunikationsPartner);
							}
						}
						setKommunikationsPartner((	de.bsvrz.sys.funclib.bitctrl.modell.tmkextlsglobal.objekte.Geraet
						) tmpKommunikationsPartner);
					// GanzzahlAttributTyp
							setPortNummer(new de.bsvrz.sys.funclib.bitctrl.modell.fachmodellglobal.attribute.AttZahlPositiv
							(daten.
								getUnscaledValue
							("PortNummer").
									longValue
							()));
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon.setBezeichnung(getBezeichnung());
							klon.setProtokollTyp(getProtokollTyp());
							klon.setKommunikationsPartner(getKommunikationsPartner());
							klon.setPortNummer(getPortNummer());
			
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}
	
		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.anschlussPunktKommunikationsPartner";

	/**
	 * Initialisiert den Konfigurationsdatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public KdAnschlussPunktKommunikationsPartner(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 
	
}
