/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Attributliste Parameter Steuerung netzweite Beeinflussung.
<p>
&lt;absatz&gt;
						Attributliste für Definition der Parameter Steuerung für netzweite Beeinflussung
            AlgoritmusAuswahl
					&lt;&#47;absatz&gt;
</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 1
 */
public class AtlNbaStrgAlgorithmusAuswahl implements Attributliste {
	
	
		/*
		 * Beginn Propertiesabschnitt
		 */
	
			private de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaAlgorithmusReisezeit
			 _algorithmus
			;
	
		/**
		Auswahl Algorithmus1 oder Algorithmus2 für die Bestimmung der Reisezeiten.
		<p>
		
		</p>
		
		@return der Wert von Algorithmus.
		*/
			public de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaAlgorithmusReisezeit
			 getAlgorithmus() {
			return _algorithmus;
		}
	
		/**
		Auswahl Algorithmus1 oder Algorithmus2 für die Bestimmung der Reisezeiten.
		<p>
		
		</p>
		
		@param _algorithmus der neue Wert von Algorithmus.
		*/
		public void setAlgorithmus(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaAlgorithmusReisezeit
		 _algorithmus) {
			this._algorithmus = _algorithmus;
		}
	
	
		/*
		 * Ende Propertiesabschnitt
		 */
	
		/*
		 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
		 */
	
		public void bean2Atl(final Data datum, final ObjektFactory factory) {
				// GanzzahlAttributTyp
				if (getAlgorithmus() != null) {
	                if (getAlgorithmus().isZustand()) {
	                    datum.getUnscaledValue("Algorithmus").setText(getAlgorithmus().toString());
	                } else {
						datum.
						getUnscaledValue
	                	("Algorithmus").set(getAlgorithmus().getValue());
	                }
				}
		}
	
		public void atl2Bean(final Data daten, final ObjektFactory factory) {
				// GanzzahlAttributTyp
						if (daten.getUnscaledValue("Algorithmus").isState()) {
							setAlgorithmus(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaAlgorithmusReisezeit
							.getZustand(daten.getScaledValue("Algorithmus").getText()));
						} else {
						setAlgorithmus(new de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaAlgorithmusReisezeit
						(daten.
							getUnscaledValue
						("Algorithmus").
								byteValue
						()));
						}
		}
	
		/*
		 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
		 */
	
	
	@Override
	public AtlNbaStrgAlgorithmusAuswahl clone() {
		AtlNbaStrgAlgorithmusAuswahl klon = new AtlNbaStrgAlgorithmusAuswahl();
		
						klon.setAlgorithmus(getAlgorithmus());
		

		return klon;
	}
	
	@Override
	public String toString() {
		return BeanUtils.toString(this);
	}
		
}
