/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.parameter;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Parameter für die meteorologische Kontrolle des Sensorwertes (Prüfung, ob Sensorwert sinnvolle Ergebnisse im Vergleich mit meteorologisch vergleichbaren Sensoren liefert).
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 25
 */
public class PdUfdsMeteorologischeKontrolleWasserFilmDicke extends AbstractParameterDatensatz<PdUfdsMeteorologischeKontrolleWasserFilmDicke.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.ParameterDefault,
					Aspekte.ParameterSoll,
					Aspekte.ParameterVorgabe,
					Aspekte.ParameterIst,
				};
			}
	
			/**
			 * Aspekt der zur Versorgung von Defaultwerten für Parameter verwendet werden kann.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterDefault = new Aspekte("Default-Parameter-Aspekt", "asp.parameterDefault");
			
			/**
			 * Wird für Parametersätze als Platzhalter verwendet und später durch die Konfiguration automatisch durch die zugesicherten Aspekte von Parametern ersetzt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterSoll = new Aspekte("Soll-Parameter-Aspekt", "asp.parameterSoll");
			
			/**
			 * Wird für Parametersätze als Platzhalter verwendet und später durch die Konfiguration automatisch durch die zugesicherten Aspekte von Parametern ersetzt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterVorgabe = new Aspekte("Vorgabe-Parameter-Aspekt", "asp.parameterVorgabe");
			
			/**
			 * Wird für Parametersätze als Platzhalter verwendet und später durch die Konfiguration automatisch durch die zugesicherten Aspekte von Parametern ersetzt.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt ParameterIst = new Aspekte("Ist-Parameter-Aspekt", "asp.parameterIst");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractOnlineDatum {
		
		/**
		 * Initialisiert das Onlinedatum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
				 _urlasser
				= new de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
				()
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsNiederschlagsIntensitaet
				 _wFDgrenzNassNI
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsRelativeLuftFeuchte
				 _wFDgrenzNassRLF
				;
				private 	RelativerZeitstempel
				 _wDFminNassRLF
				;
		
			/**
			Urlasserinformationen.
			<p>
			Urlasserinformationen bestehen aus einer Referenz auf den Benutzer, der die Meldung erzeugt hat, einer Angabe der Ursache für die Meldung und einem Veranlasser für die Meldung.
			</p>
			
			@return der Wert von Urlasser.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
				 getUrlasser() {
				return _urlasser;
			}
		
			/**
			Urlasserinformationen.
			<p>
			Urlasserinformationen bestehen aus einer Referenz auf den Benutzer, der die Meldung erzeugt hat, einer Angabe der Ursache für die Meldung und einem Veranlasser für die Meldung.
			</p>
			
			@param _urlasser der neue Wert von Urlasser.
			*/
			public void setUrlasser(de.bsvrz.sys.funclib.bitctrl.modell.tmvewbetriebglobal.attribute.AtlUrlasser
			 _urlasser) {
				this._urlasser = _urlasser;
			}
		
			/**
			Wenn NI &gt; WFDgrenzNassNI und WDF = 0 mm und RLF &gt; WFDgrenzNassRLF für Zeitraum &gt; WDFminNassRLF, dann WFD implausibel.
			<p>
			
			</p>
			
			@return der Wert von WFDgrenzNassNI.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsNiederschlagsIntensitaet
				 getWFDgrenzNassNI() {
				return _wFDgrenzNassNI;
			}
		
			/**
			Wenn NI &gt; WFDgrenzNassNI und WDF = 0 mm und RLF &gt; WFDgrenzNassRLF für Zeitraum &gt; WDFminNassRLF, dann WFD implausibel.
			<p>
			
			</p>
			
			@param _wFDgrenzNassNI der neue Wert von WFDgrenzNassNI.
			*/
			public void setWFDgrenzNassNI(de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsNiederschlagsIntensitaet
			 _wFDgrenzNassNI) {
				this._wFDgrenzNassNI = _wFDgrenzNassNI;
			}
		
			/**
			Wenn NI &gt; WFDgrenzNassNI und WDF = 0 mm und RLF &gt; WFDgrenzNassRLF für Zeitraum &gt; WDFminNassRLF, dann WFD implausibel.
			<p>
			
			</p>
			
			@return der Wert von WFDgrenzNassRLF.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsRelativeLuftFeuchte
				 getWFDgrenzNassRLF() {
				return _wFDgrenzNassRLF;
			}
		
			/**
			Wenn NI &gt; WFDgrenzNassNI und WDF = 0 mm und RLF &gt; WFDgrenzNassRLF für Zeitraum &gt; WDFminNassRLF, dann WFD implausibel.
			<p>
			
			</p>
			
			@param _wFDgrenzNassRLF der neue Wert von WFDgrenzNassRLF.
			*/
			public void setWFDgrenzNassRLF(de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsRelativeLuftFeuchte
			 _wFDgrenzNassRLF) {
				this._wFDgrenzNassRLF = _wFDgrenzNassRLF;
			}
		
			/**
			Wenn NI &gt; WFDgrenzNassNI und WDF = 0 mm und RLF &gt; WFDgrenzNassRLF für Zeitraum &gt; WDFminNassRLF, dann WFD implausibel.
			<p>
			
			</p>
			
			@return der Wert von WDFminNassRLF.
			*/
				public 	RelativerZeitstempel
				 getWDFminNassRLF() {
				return _wDFminNassRLF;
			}
		
			/**
			Wenn NI &gt; WFDgrenzNassNI und WDF = 0 mm und RLF &gt; WFDgrenzNassRLF für Zeitraum &gt; WDFminNassRLF, dann WFD implausibel.
			<p>
			
			</p>
			
			@param _wDFminNassRLF der neue Wert von WDFminNassRLF.
			*/
			public void setWDFminNassRLF(	RelativerZeitstempel
			 _wDFminNassRLF) {
				this._wDFminNassRLF = _wDFminNassRLF;
			}
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// AttributListenDefinition
						getUrlasser().bean2Atl(datum.getItem("Urlasser"), factory);
					// GanzzahlAttributTyp
					if (getWFDgrenzNassNI() != null) {
		                if (getWFDgrenzNassNI().isZustand()) {
		                    datum.getUnscaledValue("WFDgrenzNassNI").setText(getWFDgrenzNassNI().toString());
		                } else {
							datum.
							getScaledValue
		                	("WFDgrenzNassNI").set(getWFDgrenzNassNI().getValue());
		                }
					}
					// GanzzahlAttributTyp
					if (getWFDgrenzNassRLF() != null) {
		                if (getWFDgrenzNassRLF().isZustand()) {
		                    datum.getUnscaledValue("WFDgrenzNassRLF").setText(getWFDgrenzNassRLF().toString());
		                } else {
							datum.
							getUnscaledValue
		                	("WFDgrenzNassRLF").set(getWFDgrenzNassRLF().getValue());
		                }
					}
					// ZeitstempelAttributTyp
						datum.getTimeValue("WDFminNassRLF").setMillis(getWDFminNassRLF().getTime());
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// AttributListenDefinition
						getUrlasser().atl2Bean(daten.getItem("Urlasser"), factory);
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("WFDgrenzNassNI").isState()) {
								setWFDgrenzNassNI(de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsNiederschlagsIntensitaet
								.getZustand(daten.getScaledValue("WFDgrenzNassNI").getText()));
							} else {
							setWFDgrenzNassNI(new de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsNiederschlagsIntensitaet
							(daten.
								getScaledValue
							("WFDgrenzNassNI").
								doubleValue
							()));
							}
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("WFDgrenzNassRLF").isState()) {
								setWFDgrenzNassRLF(de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsRelativeLuftFeuchte
								.getZustand(daten.getScaledValue("WFDgrenzNassRLF").getText()));
							} else {
							setWFDgrenzNassRLF(new de.bsvrz.sys.funclib.bitctrl.modell.tmumfelddatenglobal.attribute.AttUfdsRelativeLuftFeuchte
							(daten.
								getUnscaledValue
							("WFDgrenzNassRLF").
									byteValue
							()));
							}
					// ZeitstempelAttributTyp
						setWDFminNassRLF(new
							RelativerZeitstempel
							(daten.getTimeValue("WDFminNassRLF").getMillis()));
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon._urlasser = getUrlasser().clone();
							klon.setWFDgrenzNassNI(getWFDgrenzNassNI());
							klon.setWFDgrenzNassRLF(getWFDgrenzNassRLF());
							klon.setWDFminNassRLF(getWDFminNassRLF());
			
			
			klon.dSetZeitstempel(dGetZeitstempel());
			klon.dSetDatenStatus(dGetDatenStatus());
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}

		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.ufdsMeteorologischeKontrolleWasserFilmDicke";

	/**
	 * Initialisiert den Parameterdatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public PdUfdsMeteorologischeKontrolleWasserFilmDicke(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 

}
