/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmvewprotokolleglobal.attribute;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Variable Elemente eines Skripts (Tripel aus Objekttyp, Attributgruppe und Aspekt).
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 1
 */
public class AtlSkriptVariableElemente implements Attributliste {
	
	
		/*
		 * Beginn Propertiesabschnitt
		 */
	
			private String
			 _objekttyp
			= new String
			()
			;
			private String
			 _attributgruppe
			= new String
			()
			;
			private String
			 _aspekt
			= new String
			()
			;
	
		/**
		PID des Objekts.
		<p>
		
		</p>
		
		@return der Wert von Objekttyp.
		*/
			public String
			 getObjekttyp() {
			return _objekttyp;
		}
	
		/**
		PID des Objekts.
		<p>
		
		</p>
		
		@param _objekttyp der neue Wert von Objekttyp.
		*/
		public void setObjekttyp(String
		 _objekttyp) {
			if (_objekttyp.length() > 32767) {
				throw new IllegalArgumentException("Der Text darf nicht länger als " + 32767 + " Zeichen sein.");
			}
			this._objekttyp = _objekttyp;
		}
	
		/**
		PID der Attributgruppe.
		<p>
		
		</p>
		
		@return der Wert von Attributgruppe.
		*/
			public String
			 getAttributgruppe() {
			return _attributgruppe;
		}
	
		/**
		PID der Attributgruppe.
		<p>
		
		</p>
		
		@param _attributgruppe der neue Wert von Attributgruppe.
		*/
		public void setAttributgruppe(String
		 _attributgruppe) {
			if (_attributgruppe.length() > 32767) {
				throw new IllegalArgumentException("Der Text darf nicht länger als " + 32767 + " Zeichen sein.");
			}
			this._attributgruppe = _attributgruppe;
		}
	
		/**
		Aspekts oder ungebundener Aspekt.
		<p>
		
		</p>
		
		@return der Wert von Aspekt.
		*/
			public String
			 getAspekt() {
			return _aspekt;
		}
	
		/**
		Aspekts oder ungebundener Aspekt.
		<p>
		
		</p>
		
		@param _aspekt der neue Wert von Aspekt.
		*/
		public void setAspekt(String
		 _aspekt) {
			if (_aspekt.length() > 32767) {
				throw new IllegalArgumentException("Der Text darf nicht länger als " + 32767 + " Zeichen sein.");
			}
			this._aspekt = _aspekt;
		}
	
	
		/*
		 * Ende Propertiesabschnitt
		 */
	
		/*
		 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
		 */
	
		public void bean2Atl(final Data datum, final ObjektFactory factory) {
				// ZeichenkettenAttributTyp
				if (getObjekttyp() != null) {
					datum.getTextValue("Objekttyp").setText(getObjekttyp());
				}
				// ZeichenkettenAttributTyp
				if (getAttributgruppe() != null) {
					datum.getTextValue("Attributgruppe").setText(getAttributgruppe());
				}
				// ZeichenkettenAttributTyp
				if (getAspekt() != null) {
					datum.getTextValue("Aspekt").setText(getAspekt());
				}
		}
	
		public void atl2Bean(final Data daten, final ObjektFactory factory) {
				// ZeichenkettenAttributTyp
					setObjekttyp(daten.getTextValue("Objekttyp").getText());
				// ZeichenkettenAttributTyp
					setAttributgruppe(daten.getTextValue("Attributgruppe").getText());
				// ZeichenkettenAttributTyp
					setAspekt(daten.getTextValue("Aspekt").getText());
		}
	
		/*
		 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
		 */
	
	
	@Override
	public AtlSkriptVariableElemente clone() {
		AtlSkriptVariableElemente klon = new AtlSkriptVariableElemente();
		
						klon.setObjekttyp(getObjekttyp());
						klon.setAttributgruppe(getAttributgruppe());
						klon.setAspekt(getAspekt());
		

		return klon;
	}
	
	@Override
	public String toString() {
		return BeanUtils.toString(this);
	}
		
}
