/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.impl;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Definiert einen Datenverteiler mit seinen Eigenschaften.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 1
 */
public class DatenverteilerImpl extends AbstractSystemObjekt
	implements de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.Datenverteiler { 

	/**
	 * Der Defaultkonstruktor wird für das Erzeugen des Systemobjekts über per
	 * Reflection-API benötigt.
	 */
	public DatenverteilerImpl() {
		// tut nix
	}
	
	/**
	 * Initialisierung.
	 * 
	 * @param objekt
	 *            ein beliebiges Systemobjekt.
	 * @param factory
	 *            die Fabrik, die das Systemobjekt angelegt hat.
	 */
	public DatenverteilerImpl(final SystemObject objekt, final ObjektFactory factory) {
		super(objekt, factory);
		
		if (!objekt.isOfType(getTyp().getPid())) {
			throw new IllegalArgumentException(
					"Systemobjekt ist kein Datenverteiler.");
		}
	}
	
	@Override
	protected String doGetTypPid() {
		return PID;
	}
	
	/*
	 * Beginn Abschnitt Mengen
	 */
	
	private AenderbareMenge<de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.Applikation> applikationen;
	
	public AenderbareMenge<de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.Applikation> getApplikationen() {
		if (applikationen == null) {
			ConfigurationObject ko = (ConfigurationObject) getSystemObject();
			if (ko.getObjectSet("Applikationen") == null) {
				// Die Menge ist nicht konfiguriert
				return null;
			}
			applikationen = new AenderbareMenge<de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.Applikation>(getObjektFactory(), (MutableSet)ko.getObjectSet("Applikationen"), 0, 0, this);
		}
		return applikationen;
	}

	/*
	 * Ende Abschnitt Mengen
	 */

	/*
	 * Beginn Abschnitt Attributgruppen
	 */

	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdAngemeldeteApplikationen getOdAngemeldeteApplikationen() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdAngemeldeteApplikationen.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdTerminierung getOdTerminierung() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdTerminierung.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdKonfigurationsAntwort getOdKonfigurationsAntwort() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdKonfigurationsAntwort.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdDefaultParameterdatensaetze getKdDefaultParameterdatensaetze() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdDefaultParameterdatensaetze.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdDistributionspaketReleaseInfo getOdDistributionspaketReleaseInfo() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdDistributionspaketReleaseInfo.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdKonfigurationsSchreibAntwort getOdKonfigurationsSchreibAntwort() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdKonfigurationsSchreibAntwort.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdDatenverteilerSchnittstelle getOdDatenverteilerSchnittstelle() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdDatenverteilerSchnittstelle.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdInfo getKdInfo() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdInfo.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdAlternativeObjektbezeichnung getKdAlternativeObjektbezeichnung() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.konfigurationsdaten.KdAlternativeObjektbezeichnung.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdTelegrammLaufzeiten getOdTelegrammLaufzeiten() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdTelegrammLaufzeiten.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.parameter.PdDeaktivierteVerbindungen getPdDeaktivierteVerbindungen() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.parameter.PdDeaktivierteVerbindungen.class);
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdDatenverteilerKommunikationsZustand getOdDatenverteilerKommunikationsZustand() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdDatenverteilerKommunikationsZustand.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdDatenverteilerRechtepruefung getOdDatenverteilerRechtepruefung() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdDatenverteilerRechtepruefung.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdArchivAntwort getOdArchivAntwort() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.onlinedaten.OdArchivAntwort.class); 
	}
	
	public de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.konfigurationsdaten.KdDatenverteilerEigenschaften getKdDatenverteilerEigenschaften() {
		return getDatensatz(de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.konfigurationsdaten.KdDatenverteilerEigenschaften.class);
	}
	
	
	/*
	 * Ende Abschnitt Attributgruppen
	 */
	
	// Sonderfall Klasse AttributImpl
	 

}
