/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmkexlmstic3.attribute;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Wochentag, TIC3 DaysOfWeekEnum.
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 1
 */
public class AttTic3Wochentag extends Zahl<		Byte
> {
	
	private static final long serialVersionUID = 1L;
	
	
	/**
	
	<p>
	
	</p>
	*/
	public static final AttTic3Wochentag ZUSTAND_1N_UNBEKANNT = new AttTic3Wochentag("Unbekannt", 		Byte
	.valueOf("-1"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttTic3Wochentag ZUSTAND_1_MONTAG = new AttTic3Wochentag("Montag", 		Byte
	.valueOf("1"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttTic3Wochentag ZUSTAND_2_DIENSTAG = new AttTic3Wochentag("Dienstag", 		Byte
	.valueOf("2"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttTic3Wochentag ZUSTAND_3_MITTWOCH = new AttTic3Wochentag("Mittwoch", 		Byte
	.valueOf("3"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttTic3Wochentag ZUSTAND_4_DONNERSTAG = new AttTic3Wochentag("Donnerstag", 		Byte
	.valueOf("4"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttTic3Wochentag ZUSTAND_5_FREITAG = new AttTic3Wochentag("Freitag", 		Byte
	.valueOf("5"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttTic3Wochentag ZUSTAND_6_SONNABEND = new AttTic3Wochentag("Sonnabend", 		Byte
	.valueOf("6"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttTic3Wochentag ZUSTAND_7_SONNTAG = new AttTic3Wochentag("Sonntag", 		Byte
	.valueOf("7"));

	/**
	 * Gibt den Zustand zu einer Zahl zurück oder <code>null</code>, wenn die
	 * Zahl keinen Zustand repräsentiert.
	 *
	 * @param value ein Zahlenwert
	 * @return der Zustand zu dem Zahlenwert oder <code>null</code>, wenn die
	 * Zahl keine Entsprechnung als Zustand besitzt.
	 */
	public static AttTic3Wochentag getZustand(final 		Byte
	 value) {
		for (AttTic3Wochentag e : getZustaende()) {
			if (e.getValue().equals(value)) {
				return e;
			}
		}
		return null;
	}
	
	/**
	 * Gibt den Zustand zu einem Zustandsnamen zurück oder <code>null</code>,
	 * wenn kein Zustand einen solchen Namen hat.
	 * 
	 * @param value
	 *            der Zustandsname
	 * @return der Zustand zu dem Zustandsnamen oder <code>null</code>, wenn
	 *         kein Zustand einen solchen Namen hat.
	 */
	public static AttTic3Wochentag getZustand(final String value) {
		for (AttTic3Wochentag e : getZustaende()) {
			if (e.toString().equals(value)) {
				return e;
			}
		}
		return null;
	}
	
	/**
	 * Gibt alle Zustände zurück, die das Attribut besitzen kann.
	 *
	 * @return alle Zustände die das Attribut annehmen kann.
	 */
	public static List<AttTic3Wochentag> getZustaende() {
		List<AttTic3Wochentag> list = new ArrayList<AttTic3Wochentag>();
		list.add(ZUSTAND_1N_UNBEKANNT);
		list.add(ZUSTAND_1_MONTAG);
		list.add(ZUSTAND_2_DIENSTAG);
		list.add(ZUSTAND_3_MITTWOCH);
		list.add(ZUSTAND_4_DONNERSTAG);
		list.add(ZUSTAND_5_FREITAG);
		list.add(ZUSTAND_6_SONNABEND);
		list.add(ZUSTAND_7_SONNTAG);
		return list;
	}	
	/**
	 * Erzeugte eine neues Attribut .
	 *
	 * @param value der Wert der Zahl.
	 */
	public AttTic3Wochentag(final 		Byte
	 value) {
		super(value);
	}
	
	private AttTic3Wochentag(final String zustand, final 		Byte
	 value) {
		super(zustand, value);
	}
	
}
