/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Information zum Programmstatus (Mischung Betriebsartrückmeldung und Steuerungsstatus).
<p>

</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 21
 */
public class AttNbaSteuerungProgrammStatus extends Zahl<		Byte
> {
	
	private static final long serialVersionUID = 1L;
	
	
	/**
	
	<p>
	
	</p>
	*/
	public static final AttNbaSteuerungProgrammStatus ZUSTAND_0_UNDEFINIERT = new AttNbaSteuerungProgrammStatus("Undefiniert", 		Byte
	.valueOf("0"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttNbaSteuerungProgrammStatus ZUSTAND_1_EXTERN = new AttNbaSteuerungProgrammStatus("Extern", 		Byte
	.valueOf("1"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttNbaSteuerungProgrammStatus ZUSTAND_2_AUTARK = new AttNbaSteuerungProgrammStatus("Autark", 		Byte
	.valueOf("2"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttNbaSteuerungProgrammStatus ZUSTAND_3_HAND_VOR_ORT = new AttNbaSteuerungProgrammStatus("Hand vor Ort", 		Byte
	.valueOf("3"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttNbaSteuerungProgrammStatus ZUSTAND_4_AUTOMATIK = new AttNbaSteuerungProgrammStatus("Automatik", 		Byte
	.valueOf("4"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttNbaSteuerungProgrammStatus ZUSTAND_5_SONDERPROGRAMM = new AttNbaSteuerungProgrammStatus("Sonderprogramm", 		Byte
	.valueOf("5"));

	/**
	
	<p>
	
	</p>
	*/
	public static final AttNbaSteuerungProgrammStatus ZUSTAND_6_HANDPROGRAMM = new AttNbaSteuerungProgrammStatus("Handprogramm", 		Byte
	.valueOf("6"));

	/**
	 * Gibt den Zustand zu einer Zahl zurück oder <code>null</code>, wenn die
	 * Zahl keinen Zustand repräsentiert.
	 *
	 * @param value ein Zahlenwert
	 * @return der Zustand zu dem Zahlenwert oder <code>null</code>, wenn die
	 * Zahl keine Entsprechnung als Zustand besitzt.
	 */
	public static AttNbaSteuerungProgrammStatus getZustand(final 		Byte
	 value) {
		for (AttNbaSteuerungProgrammStatus e : getZustaende()) {
			if (e.getValue().equals(value)) {
				return e;
			}
		}
		return null;
	}
	
	/**
	 * Gibt den Zustand zu einem Zustandsnamen zurück oder <code>null</code>,
	 * wenn kein Zustand einen solchen Namen hat.
	 * 
	 * @param value
	 *            der Zustandsname
	 * @return der Zustand zu dem Zustandsnamen oder <code>null</code>, wenn
	 *         kein Zustand einen solchen Namen hat.
	 */
	public static AttNbaSteuerungProgrammStatus getZustand(final String value) {
		for (AttNbaSteuerungProgrammStatus e : getZustaende()) {
			if (e.toString().equals(value)) {
				return e;
			}
		}
		return null;
	}
	
	/**
	 * Gibt alle Zustände zurück, die das Attribut besitzen kann.
	 *
	 * @return alle Zustände die das Attribut annehmen kann.
	 */
	public static List<AttNbaSteuerungProgrammStatus> getZustaende() {
		List<AttNbaSteuerungProgrammStatus> list = new ArrayList<AttNbaSteuerungProgrammStatus>();
		list.add(ZUSTAND_0_UNDEFINIERT);
		list.add(ZUSTAND_1_EXTERN);
		list.add(ZUSTAND_2_AUTARK);
		list.add(ZUSTAND_3_HAND_VOR_ORT);
		list.add(ZUSTAND_4_AUTOMATIK);
		list.add(ZUSTAND_5_SONDERPROGRAMM);
		list.add(ZUSTAND_6_HANDPROGRAMM);
		return list;
	}	
	/**
	 * Erzeugte eine neues Attribut NbaSteuerungProgrammStatus.
	 *
	 * @param value der Wert der Zahl.
	 */
	public AttNbaSteuerungProgrammStatus(final 		Byte
	 value) {
		super(value);
	}
	
	private AttNbaSteuerungProgrammStatus(final String zustand, final 		Byte
	 value) {
		super(zustand, value);
	}
	
}
