/*
 * Java-Modell des Datenkatalogs.
 * Copyright (C) 2016 BitCtrl Systems GmbH 
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.onlinedaten;

import java.util.*;

import com.bitctrl.beans.*;

import de.bsvrz.dav.daf.main.*;
import de.bsvrz.dav.daf.main.config.*;
import de.bsvrz.sys.funclib.bitctrl.modell.*;
import de.bsvrz.sys.funclib.bitctrl.modell.annotation.*;
import de.bsvrz.sys.funclib.bitctrl.modell.att.*;
import de.bsvrz.sys.funclib.bitctrl.modell.impl.*;

/**
Attributgruppe zur Übergabe des Befehls-Status.
<p>
&lt;absatz&gt;
						Attributgruppe zur Übergabe des Befehls-Status
					&lt;&#47;absatz&gt;
</p>
* @author BitCtrl Systems GmbH, M2T
 * @version Gültig seit KB-Version 21
 */
public class OdAnzeigeQuerschnittStatusBefehle extends AbstractOnlineDatensatz<OdAnzeigeQuerschnittStatusBefehle.Daten> {

		/**
		 * Die vorhandenen Aspekte des Datensatzes.
		 */
		public static class Aspekte extends de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.objekte.impl.AspektImpl implements Aspekt {
	
			public static Aspekt[] values() {
				return new Aspekt[] {
					Aspekte.NbaZustand,
				};
			}
	
			/**
			 * Aspekt für NBA-Zustände.	 
			 *
			 * <p>
			 * 
	         * </p>
			 */
			public static final Aspekt NbaZustand = new Aspekte("NbaZustand", "asp.nbaZustand");
			
			;
			
			private final String name;
			private final String pid;
	
			private Aspekte(final String name, final String pid) {
				this.name = name;
				this.pid = pid;
			}
	
			@Override
			public String getName() {
				if (getSystemObject() == null) {
					return name;
				}
				return super.getName();
			}
	
			@Override
			public String getPid() {
				if (getSystemObject() == null) {
					return pid;
				}
				return super.getPid();
			}
			
			@Override
			public Aspect getSystemObject() {
				return (Aspect) super.getSystemObject();
			}
	
			@Override
			public String toString() {
				if (getSystemObject() == null) {
					return name + " (" + pid + ")";
				}
				return super.toString();
			}
	
		}
	
	/**
	 * Kapselt die Daten des Datensatzes.
	 */
	public static class Daten extends AbstractOnlineDatum {
		
		/**
		 * Initialisiert das Onlinedatum.
		 * 
		 * @param datensatz
		 *            der Datensatz zu dem das Datum gehört.
		 * @param aspekt
		 *            der Aspekt für das Datum.
		 */
		public Daten(final Datensatz datensatz, final Aspekt aspekt) {
			super(datensatz, aspekt);
		}
		
		
			/*
			 * Beginn Propertiesabschnitt
			 */
		
				private de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.attribute.AttJaNein
				 _befehleAktiv
				;
				private de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaSteuerungBefehlsStatus
				 _befehlsQuelle
				;
		
			/**
			Information, ob am AnzeigeQuerschnitt Befehle aktiv sind (eingeschaltete Anzeigen).
			<p>
			
			</p>
			
			@return der Wert von BefehleAktiv.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.attribute.AttJaNein
				 getBefehleAktiv() {
				return _befehleAktiv;
			}
		
			/**
			Information, ob am AnzeigeQuerschnitt Befehle aktiv sind (eingeschaltete Anzeigen).
			<p>
			
			</p>
			
			@param _befehleAktiv der neue Wert von BefehleAktiv.
			*/
			public void setBefehleAktiv(de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.attribute.AttJaNein
			 _befehleAktiv) {
				this._befehleAktiv = _befehleAktiv;
			}
		
			/**
			Quelle für die aktiven Befehle (Quelle mit höchster Priorität bei mehreren Quellen).
			<p>
			
			</p>
			
			@return der Wert von BefehlsQuelle.
			*/
				public de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaSteuerungBefehlsStatus
				 getBefehlsQuelle() {
				return _befehlsQuelle;
			}
		
			/**
			Quelle für die aktiven Befehle (Quelle mit höchster Priorität bei mehreren Quellen).
			<p>
			
			</p>
			
			@param _befehlsQuelle der neue Wert von BefehlsQuelle.
			*/
			public void setBefehlsQuelle(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaSteuerungBefehlsStatus
			 _befehlsQuelle) {
				this._befehlsQuelle = _befehlsQuelle;
			}
		
		
			/*
			 * Ende Propertiesabschnitt
			 */
		
			/*
			 * Beginn Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			public void bean2Atl(final Data datum, final ObjektFactory factory) {
					// GanzzahlAttributTyp
					if (getBefehleAktiv() != null) {
		                if (getBefehleAktiv().isZustand()) {
		                    datum.getUnscaledValue("BefehleAktiv").setText(getBefehleAktiv().toString());
		                } else {
							datum.
							getUnscaledValue
		                	("BefehleAktiv").set(getBefehleAktiv().getValue());
		                }
					}
					// GanzzahlAttributTyp
					if (getBefehlsQuelle() != null) {
		                if (getBefehlsQuelle().isZustand()) {
		                    datum.getUnscaledValue("BefehlsQuelle").setText(getBefehlsQuelle().toString());
		                } else {
							datum.
							getUnscaledValue
		                	("BefehlsQuelle").set(getBefehlsQuelle().getValue());
		                }
					}
			}
		
			public void atl2Bean(final Data daten, final ObjektFactory factory) {
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("BefehleAktiv").isState()) {
								setBefehleAktiv(de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.attribute.AttJaNein
								.getZustand(daten.getScaledValue("BefehleAktiv").getText()));
							} else {
							setBefehleAktiv(new de.bsvrz.sys.funclib.bitctrl.modell.metamodellglobal.attribute.AttJaNein
							(daten.
								getUnscaledValue
							("BefehleAktiv").
									byteValue
							()));
							}
					// GanzzahlAttributTyp
							if (daten.getUnscaledValue("BefehlsQuelle").isState()) {
								setBefehlsQuelle(de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaSteuerungBefehlsStatus
								.getZustand(daten.getScaledValue("BefehlsQuelle").getText()));
							} else {
							setBefehlsQuelle(new de.bsvrz.sys.funclib.bitctrl.modell.tmnbaglobal.attribute.AttNbaSteuerungBefehlsStatus
							(daten.
								getUnscaledValue
							("BefehlsQuelle").
									byteValue
							()));
							}
			}
		
			/*
			 * Ende Abschnitt Konvertierung Datenverteiler <-> Modell
			 */
		
			
		@Override
		public Daten clone() {
			final Daten klon = new Daten(dGetDatensatz(), dGetAspekt());
	
							klon.setBefehleAktiv(getBefehleAktiv());
							klon.setBefehlsQuelle(getBefehlsQuelle());
			
			
			klon.dSetZeitstempel(dGetZeitstempel());
			klon.dSetDatenStatus(dGetDatenStatus());
	
			return klon;
		}

		@Override
		public String toString() {
			return BeanUtils.toString(this);
		}
	
	}

		/** Die PID der Attributgruppe im Datenverteiler. */
		public static final String PID = "atg.anzeigeQuerschnittStatusBefehle";

	/**
	 * Initialisiert den Onlinedatensatz.
	 * 
	 * @param systemObjekt
	 *            das Systemobjekt zu dem der Datensatz gehört.
	 * @param objektFactory
	 *            die ObjektFabrik, die der Datensatz verwenden soll.
	 */
	public OdAnzeigeQuerschnittStatusBefehle(final SystemObjekt systemObjekt,
			final ObjektFactory objektFactory) {
		super(systemObjekt, objektFactory);
	}

	
		@Override
		public void init(final SystemObject systemObject,
				final ObjektFactory objektFactory) {
			super.init(systemObject, objektFactory);
			for (final Aspekt asp : Aspekte.values()) {
				((AbstractSystemObjekt) asp).init(objektFactory.getModellobjekt(asp.getPid()).getSystemObject(), objektFactory);
			}
		}
		
		@Override
		protected String doGetPid() {
			return PID;
		}
	
		public Collection<? extends Aspekt> getAspekte() {
			return Arrays.asList(Aspekte.values());
		}
	
		public Daten createDatum() {
			Daten datum = new Daten(this, null);
			// TODO Auslesen der Defaultwerte geht nicht,
			// weil der Datenverteiler für Attribute ohne Defaultwert initial ungültige Werte setzt!!
			// datum.atl2Bean(createSendeCache(), getObjektFactory());
			return datum;
		}
		 
	
}
